//
//	colorvw.h
//
//	Copyright (c) 1993, by Liant Software Corp.
//	ALL RIGHTS RESERVED.
//
//	Revision History:
//	-----------------
//	06/29/92	mxs	Created

#ifndef colorvw_h
#define colorvw_h
#include "appview.h"

CLASS VBrush;
CLASS VPushButton;
CLASS VScrollBar;
CLASS VTextBox;
CLASS VTimer;
CLASS VView;

CLASS ColorView : public VAppView {

//---------------------------------------------------------------------------
//                              PUBLIC SECTION
//---------------------------------------------------------------------------
public:
	ColorView();
	~ColorView();
	VClass 					*iam();
	boolean 					free();

	boolean					rgbValueChanged(int amount);	//
	boolean					cValueChanged(int amount);		//
	boolean					mValueChanged(int amount);		// scrollbar 
	boolean					yValueChanged(int amount);		// callbacks
	boolean					kValueChanged(int amount);		//

	boolean 					play(VPushButton *btn);			// pushbutton callback
	boolean					exit(VPushButton *btn);

	boolean					timeout(VTimer *t);				// timer callback

	virtual boolean 		givenFocus();						// overridden
	virtual boolean 		paint();								// member functions


//---------------------------------------------------------------------------
//                            PROTECTED SECTION
//---------------------------------------------------------------------------
protected:

//---------------------------------------------------------------------------
//                              PRIVATE SECTION
//---------------------------------------------------------------------------
private:
	VBrush 					*rBrush;
	VBrush 					*gBrush;
	VBrush 					*bBrush;

	VBrush 					*cBrush;
	VBrush 					*mBrush;
	VBrush 					*yBrush;
	VBrush 					*kBrush;

	VScrollBar 				*rScrollBar;	
	VScrollBar 				*gScrollBar;
	VScrollBar 				*bScrollBar;

	VScrollBar 				*cScrollBar;
	VScrollBar 				*mScrollBar;
	VScrollBar 				*yScrollBar;
	VScrollBar 				*kScrollBar;

	VView 					*rColorBox;
	VView 					*gColorBox;
	VView 					*bColorBox;

	VView 					*cColorBox;
	VView 					*mColorBox;
	VView 					*yColorBox;
	VView 					*kColorBox;

	VTextBox 				*rEdit;
	VTextBox 				*gEdit;
	VTextBox 				*bEdit;

	VTextBox 				*cEdit;
	VTextBox 				*mEdit;
	VTextBox 				*yEdit;
	VTextBox 				*kEdit;

	VBrush 					*brush;
	VView 					*colorBox;

	VPushButton 			*playButton;
	VPushButton				*exitButton;

	VTimer 					*timer;

	//---------- Private member functions ------------

	int						minimum(int x, int y, int z);
	int						maximum(int x, int y, int z);

};

extern VClass *ColorViewCls;
#endif // colorvw_h
